'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _textToolbar = require('./utils/textToolbar');

var _hoverToolbar = require('./decorators/hover-toolbar');

var _hoverToolbar2 = _interopRequireDefault(_hoverToolbar);

var _focusedToolbar = require('./decorators/focused-toolbar');

var _focusedToolbar2 = _interopRequireDefault(_focusedToolbar);

var _linkStrategy = require('./linkStrategy');

var _linkStrategy2 = _interopRequireDefault(_linkStrategy);

var _Link = require('./Link');

var _Link2 = _interopRequireDefault(_Link);

var _styles = {
  "draft-sidebar": "draftJsEmojiPlugin__draft-sidebar__iGLU3",
  "item": "draftJsEmojiPlugin__item__16yus",
  "menu": "draftJsEmojiPlugin__menu__2kTke",
  "toolbar": "draftJsEmojiPlugin__toolbar__2NV21",
  "toolbar-item": "draftJsEmojiPlugin__toolbar-item__ZQoML",
  "toolbar-item-active": "draftJsEmojiPlugin__toolbar-item-active__1MJoi"
};

var _styles2 = _interopRequireDefault(_styles);

var _airToolbar = require('./air-toolbar');

var _airToolbar2 = _interopRequireDefault(_airToolbar);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectDestructuringEmpty(obj) { if (obj == null) throw new TypeError("Cannot destructure undefined"); }

var defaultTheme = _extends({}, _styles2.default);

var toolbarPlugin = function toolbarPlugin(config) {
  var theme = config.theme ? config.theme : defaultTheme;
  var toolbarHandler = config.toolbarHandler || _airToolbar2.default;

  if (config.animations === false) {
    _airToolbar2.default.animations = false;
  }

  return {
    // Re-Render the text-toolbar onChange (on selection change)
    onChange: function onChange(editorState, _ref) {
      var setEditorState = _ref.setEditorState;

      var props = {
        uid: 'text-toolbar',
        actions: (0, _textToolbar.getToolbarActions)(config, editorState, setEditorState),
        editorState: editorState,
        getTargetRectangle: _textToolbar.getToolbarPosition,
        setEditorState: setEditorState,
        theme: theme
      };
      if (toolbarHandler.textMode !== 'select' || (0, _textToolbar.shouldRenderToolbar)(editorState)) {
        toolbarHandler.add(props);
      } else {
        toolbarHandler.remove(props);
      }
      return editorState;
    },
    // Wrap all block-types in hover-toolbar decorator
    blockRendererFn: function blockRendererFn(contentBlock, _ref2) {
      _objectDestructuringEmpty(_ref2);

      return {
        decorators: [(toolbarHandler.blockMode === 'hover' ? _hoverToolbar2.default : _focusedToolbar2.default)(theme, toolbarHandler)]
      };
    },
    // Add linkStrategy decorator to draft ediotr
    decorators: [{
      strategy: _linkStrategy2.default,
      component: _Link2.default
    }]
  };
};

exports.default = toolbarPlugin;